#property  copyright "Copyright  2005, Yura Prokofiev"
#property  link      "Yura.prokofiev@gmail.com"
#property description "Modified by LexLampard  2015"

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color2  clrRed
#property  indicator_color3  clrBlue
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_width2 1
#property indicator_width3 1
#property indicator_level1  -0.25 // -0.25
#property indicator_level2  0.25  // 0.25

extern int              = 70;
extern double _Buy     = 0.25;  // 0.25
extern double _Sell    = -0.25; // -0.25
extern bool               = TRUE;//(TRUE)
extern string _   = "alert2.wav";//("alert2.wav")
extern string FontName        = "Verdana";
extern int    FontSize        = 12; 
double         ExtBuffer1[];
double         ExtBuffer2[];
double         ExtBuffer3[];
bool Buy, Sell;
string MyName = "Fisher_LexLmod";
string BS;
color clr1 = clrRed, clr2 = clrGreen;

void OnInit(void)
  {
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtBuffer3);
   IndicatorDigits(2);

   IndicatorShortName("Fisher_LexLmod line (" + DoubleToStr(, 0) + ")");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   Buy  = TRUE;
   Sell = TRUE;
  }
  
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int    limit;
   double prev,current;
   double Value=0,Value1=0,Value2=0,Fish=0,Fish1=0,Fish2=0;
   double price;
   double MinL=0;
   double MaxH=0; 
   int counted_bars=prev_calculated;
   if(counted_bars>0) counted_bars--;
   limit=rates_total-counted_bars; 
   for(int i=0; i<limit; i++)
    {
      MaxH = high[iHighest(NULL,0,MODE_HIGH,,i)];
      MinL = low[iLowest(NULL,0,MODE_LOW,,i)];
      price = NormalizeDouble((high[i]+low[i])/2,Digits);
      if(MaxH-MinL == 0) Value = NormalizeDouble(0.33*2*(0-0.5) + 0.67*Value1,Digits); 
      else Value = NormalizeDouble(0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value1,Digits);     
      Value=MathMin(MathMax(Value,-0.999),0.999); 
      if(1-Value == 0) ExtBuffer1[i]=NormalizeDouble(0.5+0.5*Fish1,Digits);
      else ExtBuffer1[i]=NormalizeDouble(0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1,Digits);
      Value1=Value;
      Fish1=ExtBuffer1[i];
    }
   bool up=true;
   for(int j=limit-2; j>=0; j--)
     {
      current=ExtBuffer1[j];
      prev=ExtBuffer1[j+1];
           
      if (((current<0)&&(prev>0))||(current<0))   up= false;    
      if (((current>0)&&(prev<0))||(current>0))   up= true;
      
      if(!up)
        {
         ExtBuffer3[j]=current;
         ExtBuffer2[j]=0.0;
        }
        
       else
         {
          ExtBuffer2[j]=current;
          ExtBuffer3[j]=0.0;
         }
     }
   if (ExtBuffer1[0] > 0 && ExtBuffer1[0] < _Buy)  { BS = "WAIT"; clr2 = clrGreen;}
   if (ExtBuffer1[0] < 0 && ExtBuffer1[0] > _Sell) { BS = "WAIT"; clr2 = clrGreen;}
   if (ExtBuffer1[0] >= _Buy) Sell = TRUE;
   if (ExtBuffer1[0] <= _Sell) Buy = TRUE;
   if (Buy && ExtBuffer1[0] > _Buy)
   {
      if ()
      {
         PlaySound(_);
      }
      //Comment(": Buy");
      BS = "BUY"; 
      clr2 = clrRed; 
      Buy = FALSE;
   }
   if (Sell && ExtBuffer1[0] < _Sell)
   {
      if ()
      {
         PlaySound(_);
      }
      //Comment(": Sell");
      BS = "SELL";
      clr2 = clrBlue; 
      Sell = FALSE;
   }
   DrawLabel();
//---- done
   return(rates_total);
  }
  
void DrawLabel()
{
     int subWin =ChartWindowFind();
     string name12, name11;         
     int x12, y12, x11, y11;
     
     long current_chart_id=ChartID();
     string text12, text11;            //  ;
     
     name11 =MyName + "Lab11";
     name12 =MyName + "Lab12";

     if(ExtBuffer1[0] < 0) text11 = BS+"(" + DoubleToString(ExtBuffer1[0]-_Sell,2) + ") =>  " ;
     if(ExtBuffer1[0] > 0) text11 = BS+"(" + DoubleToString(ExtBuffer1[0]-_Buy,2) + ") =>  " ;
     
     text12 = DoubleToString(ExtBuffer1[0],2);
     x11 = 80; y11 = 20;
     x12 = 40; y12 = 20;

     ObjectCreate(current_chart_id,name11,OBJ_LABEL,subWin,0,0);
     ObjectSetInteger(current_chart_id,name11,OBJPROP_XDISTANCE,x11);
     ObjectSetInteger(current_chart_id,name11,OBJPROP_YDISTANCE,y11);
     ObjectSetInteger(current_chart_id,name11,OBJPROP_CORNER,1);
     ObjectSetString(current_chart_id,name11,OBJPROP_TEXT, text11);

     ObjectSetString(current_chart_id,name11,OBJPROP_FONT,FontName);
     ObjectSetInteger(current_chart_id,name11,OBJPROP_FONTSIZE,FontSize);
     ObjectSetInteger(current_chart_id,name11,OBJPROP_COLOR,clr2);
     ObjectSetInteger(current_chart_id,name11,OBJPROP_ANCHOR,ANCHOR_RIGHT_UPPER);
     ObjectCreate(current_chart_id,name12,OBJ_LABEL,subWin,0,0);
     ObjectSetInteger(current_chart_id,name12,OBJPROP_XDISTANCE,x12);
     ObjectSetInteger(current_chart_id,name12,OBJPROP_YDISTANCE,y12);
     ObjectSetInteger(current_chart_id,name12,OBJPROP_CORNER,1);
     ObjectSetString(current_chart_id,name12,OBJPROP_TEXT, text12);

     ObjectSetString(current_chart_id,name12,OBJPROP_FONT,FontName);
     ObjectSetInteger(current_chart_id,name12,OBJPROP_FONTSIZE,FontSize);
     ObjectSetInteger(current_chart_id,name12,OBJPROP_COLOR,clr1);
     ObjectSetInteger(current_chart_id,name12,OBJPROP_ANCHOR,ANCHOR_RIGHT_UPPER);

}